      SUBROUTINE FLEX(PROBLM,NPR,SIZE,CONVER,INFO)
      EXTERNAL PROBLM
      INTEGER NPR,INFO
      REAL SIZE,CONVER
C
C     * * * * * * P R O G R A M  F L E X I P L E X * * * * * *
C
C     NX      TOTAL NUMBER OF INDEPENDENT VARIABLES
C     NC      TOTAL NUMBER OF EQUALITY CONSTRAINTS
C     NIC     TOTAL NUMBER OF INEQUALITY CONSTRAINTS
C     SIZE    EDGE LENGTH OF THE INITIAL POLYHEDRON
C     CONVER  CONVERGENCE CRITERION FOR TERMINATION OF THE SEARCH
C     ALFA    THE REFLECTION COEFFICIENT
C     BETA    THE CONTRACTION COEFFICIENT
C     GAMA    THE EXPANSION COEFFICIENT
C     X(I)    THE ASSUMED VECTOR TO INITIATE THE SEARCH
C     FDIFER  THE TOLERANCE CRITERION FOR CONSTRAINT VIOLATION
C     ICONT   A COUNTER TO RECORD STAGE COMPUTATIONS
C     NCONT   A COUNTER TO PRINT INFORMATION EVERY (NX+1) STAGE
C     LOW     AN INDEX TO IDENTIFY INFORMATION RELATED TO THE LOWEST
C             VALUE OF OBJECTIVE FUNCTION IN MOST RECENT POLYHEDRON
C     LHIGH   AN INDNX TO IDENTIFY INFORMATION RELATED TO LARGEST VALUE
C             OF OBJECTIVE FUNCTION IN MOST RECENT POLYHEDRON
C     LSEC    AN INDEX TO IDENTIFY INFORMATION RELATED TO THE SECOND
C             LARGEST VALUE OF OBJECTIVE FUNCTION IN MOST RECENT
C             POLYHEDRON
C
      DIMENSION X(50),X1(50,50),X2(50,50),R(100),SUM(50),F(50),SR(50),
     1 ROLD(100),H(50)
      COMMON /FLEXC1/NX,NC,NIC,STEP,ALFA,BETA,GAMA,IN,INF,FDIFER,SEQL,
     1 K1,K2,K3,K4,K5,K6,K7,K8,K9,X,X1,X2,R,SUM,F,SR,ROLD,SCALE,FOLD
      COMMON /FLEXC2/LFEAS,L5,L6,L7,L8,L9,R1A,R2A,R3A
      ALFA=1.0
      BETA=0.5
      GAMA=2.0
      STEP=SIZE
      K1=NX+1
      K2=NX+2
      K3=NX+3
      K4=NX+4
      K5=NX+5
      K6=NC+NIC
      K7=NC+1
      K8=NC+NIC
      K9=K8+1
      N=NX-NC
      N1=N+1
      IF (N1.GE.3) GO TO 50
      N1=3
      N=2
   50 N2=N+2
      N3=N+3
      N4=N+4
      N5=N+5
      N6=N+6
      N7=N+7
      N8=N+8
      XN=N
      XNX=NX
      XN1=N1
      R1A=0.5*(SQRT(5.0)-1.0)
      R2A=R1A*R1A
      R3A=R2A*R1A
      L5=NX+5
      L6=NX+6
      L7=NX+7
      L8=NX+8
      L9=NX+9
      ICONT=1
      NCONT=1
      FDIFER=2.0*(NC+1)*STEP
      FOLD=FDIFER
      IN=N1
      CALL SUMR(PROBLM)
      SR(N1)=SQRT(SEQL)
      IF (NPR.GT.0) WRITE (NPR,763) FDIFER,SR(N1)
      IF (SR(N1).LT.FDIFER) GO TO 341
      CALL WRITEX(PROBLM,NPR)
      IF (NPR.GT.0) WRITE (NPR,757)
      INF=N1
      STEP=0.05*FDIFER
      CALL FEASBL(PROBLM,SIZE,NPR)
      IF (FOLD.LT.1.0E-9) GO TO 80
      IF (NPR.GT.0) WRITE (NPR,764)
      IF (NPR.GT.0) WRITE (NPR,116) (J,X2(INF,J),J=1,NX)
      IF (NPR.GT.0) WRITE (NPR,765) SR(INF)
  341 IF (NPR.GT.0) WRITE (NPR,35)
      IF (NPR.GT.0) WRITE (NPR,758) ICONT,FDIFER
      CALL WRITEX(PROBLM,NPR)
      FTER=R(K9)
C
C     COMPUTE CENTROID OF ALL VERTICES OF INITIAL POLYHEDRON
C
  237 STEP1=STEP*(SQRT(XNX+1.0)+XNX-1.0)/(XNX*SQRT(2.0))
      STEP2=STEP*(SQRT(XNX+1.0)-1.0)/(XNX*SQRT(2.0))
      ETA=(STEP1+(XNX-1.0)*STEP2)/(XNX+1.0)
      DO 4 J=1,NX
      X(J)=X(J)-ETA
    4 CONTINUE
      CALL START
      DO 9 I=1,N1
      DO 9 J=1,NX
      X2(I,J)=X1(I,J)
    9 CONTINUE
      DO 5 I=1,N1
      IN=I
      DO 6 J=1,NX
    6 X(J)=X2(I,J)
      CALL SUMR(PROBLM)
      SR(I)=SQRT(SEQL)
      IF (SR(I).LT.FDIFER) GO TO 8
      CALL FEASBL(PROBLM,SIZE,NPR)
      IF (FOLD.LT.1.0E-9) GO TO 80
    8 CALL PROBLM(3)
      F(I)=R(K9)
    5 CONTINUE
 1000 STEP=0.05*FDIFER
      ICONT=ICONT+1
C
C     SELECT LARGEST VALUE OF OBJECTIVE FUNCTION FROM POLYHEDRON
C     VERTICES
C
      FH=F(1)
      LHIGH=1
      DO 16 I=2,N1
      IF (F(I).LT.FH) GO TO 16
      FH=F(I)
      LHIGH=I
   16 CONTINUE
C
C     SELECT MINIMUM VALUE OF OBJECTIVE FUNCTION FROM POLYHEDRON
C     VERTICES
C
   41 FL=F(1)
      LOW=1
      DO 17 I=2,N1
      IF (FL.LT.F(I)) GO TO 17
      FL=F(I)
      LOW=I
   17 CONTINUE
      DO 86 J=1,NX
   86 X(J)=X2(LOW,J)
      IN=LOW
      CALL SUMR(PROBLM)
      SR(LOW)=SQRT(SEQL)
      IF (SR(LOW).LT.FDIFER) GO TO 87
      INF=LOW
      CALL FEASBL(PROBLM,SIZE,NPR)
      IF (FOLD.LT.1.0E-9) GO TO 80
      CALL PROBLM(3)
      F(LOW)=R(K9)
      GO TO 41
   87 CONTINUE
C
C     FIND CENTROID OF POINTS WITH I DIFFERENT THAN LHIGH
C
      DO 19 J=1,NX
      SUM2=0.0
      DO 20 I=1,N1
   20 SUM2=SUM2+X2(I,J)
   19 X2(N2,J)=1.0/XN*(SUM2-X2(LHIGH,J))
      SUM2=0.0
      DO 36 I=1,N1
      DO 36 J=1,NX
      SUM2=SUM2+(X2(I,J)-X2(N2,J))**2
   36 CONTINUE
      FDIFER=(NC+1)/XN1*SQRT(SUM2)
      IF (FDIFER.LT.FOLD) GO TO 98
      FDIFER=FOLD
      GO TO 198
   98 FOLD=FDIFER
  198 CONTINUE
      FTER=F(LOW)
  137 NCONT=NCONT+1
      IF (NCONT.LT.4*N1) GO TO 37
      IF (ICONT.LT.1500) GO TO 337
      FOLD=0.5*FOLD
  337 NCONT=0
      IF (NPR.GT.0) WRITE (NPR,35)
      IF (NPR.GT.0) WRITE (NPR,758) ICONT,FDIFER
      CALL WRITEX(PROBLM,NPR)
   37 IF (FDIFER.LT.CONVER) GO TO 81
C
C     SELECT SECOND LARGEST VALUE OF OBJECTIVE FUNCTION
C
      IF (LHIGH.EQ.1) GO TO 43
      FS=F(1)
      LSEC=1
      GO TO 44
   43 FS=F(2)
      LSEC=2
   44 DO 18 I=1,N1
      IF (LHIGH.EQ.I) GO TO 18
      IF (F(I).LT.FS) GO TO 18
      FS=F(I)
      LSEC=I
   18 CONTINUE
C
C     REFLECT HIGH POINT THROUGH CENTROID
C
      DO 61 J=1,NX
      X2(N3,J)=X2(N2,J)+ALFA*(X2(N2,J)-X2(LHIGH,J))
   61 X(J)=X2(N3,J)
      IN=N3
      CALL SUMR(PROBLM)
      SR(N3)=SQRT(SEQL)
   89 IF (SR(N3).LT.FDIFER) GO TO 82
      INF=N3
      CALL FEASBL(PROBLM,SIZE,NPR)
      IF (FOLD.LT.1.0E-9) GO TO 80
   82 CALL PROBLM(3)
      F(N3)=R(K9)
      IF (F(N3).LT.F(LOW)) GO TO 84
      IF (F(N3).LT.F(LSEC)) GO TO 92
      GO TO 60
   92 DO 93 J=1,NX
   93 X2(LHIGH,J)=X2(N3,J)
      SR(LHIGH)=SR(N3)
      F(LHIGH)=F(N3)
      GO TO 1000
C
C     EXPAND VECTOR OF SEARCH ALONG DIRECTION THROUGH CENTROID AND
C     REFLECTION VECTOR
C
   84 DO 23 J=1,NX
      X2(N4,J)=X2(N3,J)+GAMA*(X2(N3,J)-X2(N2,J))
   23 X(J)=X2(N4,J)
      IN=N4
      CALL SUMR(PROBLM)
      SR(N4)=SQRT(SEQL)
      IF (SR(N4).LT.FDIFER) GO TO 25
      INF=N4
      CALL FEASBL(PROBLM,SIZE,NPR)
      IF (FOLD.LT.1.0E-9) GO TO 80
   25 CALL PROBLM(3)
      F(N4)=R(K9)
      IF (F(LOW).LT.F(N4)) GO TO 92
      DO 26 J=1,NX
   26 X2(LHIGH,J)=X2(N4,J)
      F(LHIGH)=F(N4)
      SR(LHIGH)=SR(N4)
      GO TO 1000
   60 IF (F(N3).GT.F(LHIGH)) GO TO 64
      DO 65 J=1,NX
   65 X2(LHIGH,J)=X2(N3,J)
   64 DO 66 J=1,NX
      X2(N4,J)=BETA*X2(LHIGH,J)+(1.0-BETA)*X2(N2,J)
   66 X(J)=X2(N4,J)
      IN=N4
      CALL SUMR(PROBLM)
      SR(N4)=SQRT(SEQL)
      IF (SR(N4).LT.FDIFER) GO TO 67
      INF=N4
      CALL FEASBL(PROBLM,SIZE,NPR)
      IF (FOLD.LT.1.0E-9) GO TO 80
   67 CALL PROBLM(3)
      F(N4)=R(K9)
      IF (F(LHIGH).GT.F(N4)) GO TO 68
      DO 69 J=1,NX
      DO 69 I=1,N1
   69 X2(I,J)=0.5*(X2(I,J)+X2(LOW,J))
      DO 70 I=1,N1
      DO 71 J=1,NX
   71 X(J)=X2(I,J)
      IN=I
      CALL SUMR(PROBLM)
      SR(I)=SQRT(SEQL)
      IF (SR(I).LT.FDIFER) GO TO 72
      INF=I
      CALL FEASBL(PROBLM,SIZE,NPR)
      IF (FOLD.LT.1.0E-9) GO TO 80
   72 CALL PROBLM(3)
   70 F(I)=R(K9)
      GO TO 1000
   68 DO 73 J=1,NX
   73 X2(LHIGH,J)=X2(N4,J)
      SR(LHIGH)=SR(N4)
      F(LHIGH)=F(N4)
      GO TO 1000
   81 IF (NPR.GT.0) WRITE (NPR,760) ICONT,FDIFER
      CALL WRITEX(PROBLM,NPR)
      INFO=0
      RETURN
   80 IF (NPR.GT.0) WRITE (NPR,760) ICONT,FDIFER
      CALL WRITEX(PROBLM,NPR)
      INFO=1
      RETURN
  763 FORMAT (//' 砫 ᪮騩  = ',1PE12.5///' 㬬 
     1襭 ࠭祭 = ',1PE12.5)
  757 FORMAT (//' 砫  ᨬ ६  㤮⢮
     1 砫쭮'/' ᪮饬 ')
  764 FORMAT (//' ணࠬ 諠  ᨬ ६, 
     1 㤮⢮'/' 砫쭮 ᪮饬 :')
  116 FORMAT (/(4(' X(',I2,')=',1PE12.5,1X)))
  765 FORMAT (//' 㬬 襭 ࠭祭 = ',1PE12.5)
   35 FORMAT (//' * * * * * * * * * * * * * * * * * * * * * * * *')
  758 FORMAT (//'  蠣 ᫥ = ',I6///' 騩  = '
     1 ,1PE12.5)
  760 FORMAT (//' 饥 ᫮ 蠣 ᫥ = ',I6///' ⨣ 
     1筮 襭 = ',1PE12.5)
      END
      SUBROUTINE START
      DIMENSION A(50,50)
      DIMENSION X(50),X1(50,50),X2(50,50),R(100),SUM(50),F(50),SR(50),
     1 ROLD(100)
      COMMON /FLEXC1/NX,NC,NIC,STEP,ALFA,BETA,GAMA,IN,INF,FDIFER,SEQL,
     1 K1,K2,K3,K4,K5,K6,K7,K8,K9,X,X1,X2,R,SUM,F,SR,ROLD,SCALE,FOLD
      COMMON /FLEXC2/LFEAS,L5,L6,L7,L8,L9,R1A,R2A,R3A
      VN=NX
      STEP1=STEP/(VN*SQRT(2.0))*(SQRT(VN+1.0)+VN-1.0)
      STEP2=STEP/(VN*SQRT(2.0))*(SQRT(VN+1.0)-1.0)
      DO 1 J=1,NX
    1 A(1,J)=0.0
      DO 2 I=2,K1
      DO 4 J=1,NX
    4 A(I,J)=STEP2
      L=I-1
      A(I,L)=STEP1
    2 CONTINUE
      DO 3 I=1,K1
      DO 3 J=1,NX
    3 X1(I,J)=X(J)+A(I,J)
      RETURN
      END
      SUBROUTINE FEASBL(PROBLM,SIZE,NPR)
      EXTERNAL PROBLM
      REAL SIZE
      INTEGER NPR
C
C     SUBROUTINE FEASBL MINIMIZES THE SUM OF THE SQUARE VALUES OF THE
C     VIOLATED CONSTRAINTS; IT IS CALLED EVERY TIME THE COMBINED VALUE
C     OF THE VIOLATED CONSTRAINTS EXCEEDS THE VALUE OF THE TOLERANCE
C     CRITERION FOR THE CURRENT STAGE
C
      DIMENSION X(50),X1(50,50),X2(50,50),R(100),SUM(50),F(50),SR(50),
     1 ROLD(100),R1(100),R2(100),R3(100),FLG(10),H(50)
      COMMON /FLEXC1/NX,NC,NIC,STEP,DUM1,DUM2,DUM3,IN,INF,FDIFER,SEQL,
     1 K1,K2,K3,K4,K5,K6,K7,K8,K9,X,X1,X2,R,SUM,F,SR,ROLD,SCALE,FOLD
      COMMON /FLEXC2/LFEAS,L5,L6,L7,L8,L9,R1A,R2A,R3A
      ALFA=1.0
      BETA=0.5
      GAMA=2.0
      XNX=NX
      ICONT=0
      LCHEK=0
      ICHEK=0
      VOLD=-1960.0
      KOLD=0
   25 CALL START
      DO 3 I=1,K1
      DO 4 J=1,NX
    4 X(J)=X1(I,J)
      IN=I
      CALL SUMR(PROBLM)
    3 CONTINUE
C
C     SELECT LARGEST VALUE OF SUM(I) IN SIMPLEX
C
   28 SUMH=SUM(1)
      INDEX=1
      DO 7 I=2,K1
      IF (SUM(I).LE.SUMH) GO TO 7
      SUMH=SUM(I)
      INDEX=I
    7 CONTINUE
C
C     SELECT MINIMUM VALUE OF SUM(I) IN SIMPLEX
C
      SUML=SUM(1)
      KOUNT=1
      DO 8 I=2,K1
      IF (SUML.LE.SUM(I)) GO TO 8
      SUML=SUM(I)
      KOUNT=I
    8 CONTINUE
C
C     FIND CENTROID OF POINTS WITH I DIFFERENT THAN INDEX
C
      DO 9 J=1,NX
      SUM2=0.0
      DO 10 I=1,K1
   10 SUM2=SUM2+X1(I,J)
      X1(K2,J)=1.0/XNX*(SUM2-X1(INDEX,J))
C
C     FIND REFLECTION OF HIGH POINT THROUGH CENTROID
C
      X1(K3,J)=2.0*X1(K2,J)-X1(INDEX,J)
    9 X(J)=X1(K3,J)
      IN=K3
      CALL SUMR(PROBLM)
      IF (SUM(K3).LT.SUML) GO TO 11
C
C     SELECT SECOND LARGEST VALUE IN SIMPLEX
C
      IF (INDEX.EQ.1) GO TO 38
      SUMS=SUM(1)
      GO TO 39
   38 SUMS=SUM(2)
   39 DO 12 I=1,K1
      IF ((INDEX-I).EQ.0) GO TO 12
      IF (SUM(I).LE.SUMS) GO TO 12
      SUMS=SUM(I)
   12 CONTINUE
      IF (SUM(K3).GT.SUMS) GO TO 13
      GO TO 14
C
C     FORM EXPANSION OF NEW MINIMUM IF REFLECTION HAS PRODUCED ONE
C     MINIMUM
C
   11 DO 15 J=1,NX
      X1(K4,J)=X1(K2,J)+2.0*(X1(K3,J)-X1(K2,J))
   15 X(J)=X1(K4,J)
      IN=K4
      CALL SUMR(PROBLM)
      IF (SUM(K4).LT.SUML) GO TO 16
      GO TO 14
   13 IF (SUM(K3).GT.SUMH) GO TO 17
      DO 18 J=1,NX
   18 X1(INDEX,J)=X1(K3,J)
   17 DO 19 J=1,NX
      X1(K4,J)=0.5*X1(INDEX,J)+0.5*X1(K2,J)
   19 X(J)=X1(K4,J)
      IN=K4
      CALL SUMR(PROBLM)
      IF (SUMH.GT.SUM(K4)) GO TO 6
C
C     REDUCE SIMPLEX BY HALF IF REFLECTION TO PRODUCE A LARGER VALUE
C     THAN THE MAXIMUM
C
      DO 20 J=1,NX
      DO 20 I=1,K1
   20 X1(I,J)=0.5*(X1(I,J)+X1(KOUNT,J))
      DO 29 I=1,K1
      DO 30 J=1,NX
   30 X(J)=X1(I,J)
      IN=I
      CALL SUMR(PROBLM)
   29 CONTINUE
    5 SUML=SUM(1)
      KOUNT=1
      DO 23 I=2,K1
      IF (SUML.LT.SUM(I)) GO TO 23
      SUML=SUM(I)
      KOUNT=I
   23 CONTINUE
      SR(INF)=SQRT(SUM(KOUNT))
      DO 27 J=1,NX
   27 X(J)=X1(KOUNT,J)
      GO TO 26
    6 DO 31 J=1,NX
   31 X1(INDEX,J)=X1(K4,J)
      SUM(INDEX)=SUM(K4)
      GO TO 5
   16 DO 21 J=1,NX
      X1(INDEX,J)=X1(K4,J)
   21 X(J)=X1(INDEX,J)
      SUM(INDEX)=SUM(K4)
      SR(INF)=SQRT(SUM(K4))
      GO TO 26
   14 DO 22 J=1,NX
      X1(INDEX,J)=X1(K3,J)
   22 X(J)=X1(INDEX,J)
      SUM(INDEX)=SUM(K3)
      SR(INF)=SQRT(SUM(K3))
   26 ICONT=ICONT+1
      DO 36 J=1,NX
   36 X2(INF,J)=X(J)
      IF (ICONT.LT.2*K1) GO TO 50
      ICONT=0
      DO 24 J=1,NX
   24 X(J)=X1(K2,J)
      IN=K2
      CALL SUMR(PROBLM)
      DIFER=0.0
      DO 57 I=1,K1
   57 DIFER=DIFER+(SUM(I)-SUM(K2))**2
      DIFER=1.0/(K7*XNX)*SQRT(DIFER)
      IF (DIFER.GT.1.0E-5) GO TO 50
C
C     IF FLEXIBLE SIMPLEX METHOD FAILED TO SATISFY THE CONSTRAINTS
C     WITHIN THE TOLERANCE CRITERION FOR THE CURRENT STAGE, THE SEARCH
C     IS PERTURBED FROM THE POSITION WHERE THE X VECTOR IS STUCK AND
C     THEN FEASBL IS REPEATED ONCE MORE FROM THE BEGINNING
C
   51 IN=K1
      STEP=20.0*FDIFER
      CALL SUMR(PROBLM)
      SR(INF)=SQRT(SEQL)
      DO 52 J=1,NX
   52 X1(K1,J)=X(J)
      DO 53 J=1,NX
      FACTOR=1.0
      X(J)=X1(K1,J)+FACTOR*STEP
      X1(L9,J)=X(J)
      IN=L9
      CALL SUMR(PROBLM)
      X(J)=X1(K1,J)-FACTOR*STEP
      X1(L5,J)=X(J)
      IN=L5
      CALL SUMR(PROBLM)
   56 IF (SUM(L9).LT.SUM(K1)) GO TO 54
      IF (SUM(L5).LT.SUM(K1)) GO TO 55
      GO TO 97
   54 X1(L5,J)=X1(K1,J)
      SUM(L5)=SUM(K1)
      X1(K1,J)=X1(L9,J)
      SUM(K1)=SUM(L9)
      FACTOR=FACTOR+1.0
      X(J)=X1(K1,J)+FACTOR*STEP
      IN=L9
      CALL SUMR(PROBLM)
      GO TO 56
   55 X1(L9,J)=X1(K1,J)
      SUM(L9)=SUM(K1)
      X1(K1,J)=X1(L5,J)
      SUM(K1)=SUM(L5)
      FACTOR=FACTOR+1.0
      X(J)=X1(K1,J)-FACTOR*STEP
      IN=L5
      CALL SUMR(PROBLM)
      GO TO 56
C
C     ONE DIMENSIONAL SEARCH BY GOLDEN SECTION ALONG EACH COORDINATE
C
   97 H(J)=X1(L9,J)-X1(L5,J)
      X1(L6,J)=X1(L5,J)+H(J)*R1A
      X(J)=X1(L6,J)
      IN=L6
      CALL SUMR(PROBLM)
      X1(L7,J)=X1(L5,J)+H(J)*R2A
      X(J)=X1(L7,J)
      IN=L7
      CALL SUMR(PROBLM)
      IF (SUM(L6).GT.SUM(L7)) GO TO 68
      X1(L8,J)=X1(L5,J)+(1.0-R3A)*H(J)
      X1(L5,J)=X1(L7,J)
      X(J)=X1(L8,J)
      IN=L8
      CALL SUMR(PROBLM)
      IF (SUM(L8).GT.SUM(L6)) GO TO 76
      X1(L5,J)=X1(L6,J)
      SUM(L5)=SUM(L6)
      GO TO 75
   76 X1(L9,J)=X1(L8,J)
      SUM(L9)=SUM(L8)
      GO TO 75
   68 X1(L9,J)=X1(L6,J)
      X1(L8,J)=X1(L5,J)+R3A*H(J)
      X(J)=X1(L8,J)
      IN=L8
      CALL SUMR(PROBLM)
      STEP=SIZE
      SUM(L9)=SUM(L6)
      IF (SUM(L7).GT.SUM(L8)) GO TO 71
      X1(L5,J)=X1(L8,J)
      SUM(L5)=SUM(L8)
      GO TO 75
   71 X1(L9,J)=X1(L7,J)
      SUM(L9)=SUM(L7)
   75 IF (ABS(X1(L9,J)-X1(L5,J)).GT.0.01*FDIFER) GO TO 97
      X1(K1,J)=X1(L7,J)
      X(J)=X1(L7,J)
      SUM(K1)=SUM(L5)
      SR(INF)=SQRT(SUM(K1))
      IF (SR(INF).LT.FDIFER) GO TO 760
   53 CONTINUE
      ICHEK=ICHEK+1
      STEP=FDIFER
      IF (ICHEK.LE.2) GO TO 25
 1988 FOLD=1.0E-10
      IF (NPR.GT.0) WRITE (NPR,853)
      IF (NPR.GT.0) WRITE (NPR,850)
      IF (NPR.GT.0) WRITE (NPR,851) (J,X(J),J=1,NX)
      IF (NPR.GT.0) WRITE (NPR,852) FDIFER,SR(INF)
      GO TO 46
  760 DO 761 J=1,NX
      X2(INF,J)=X1(K1,J)
  761 X(J)=X1(K1,J)
   50 IF (VOLD.NE.SR(INF)) GO TO 10050
      IF (KOLD.GE.10) GO TO 1988
      KOLD=KOLD+1
      GO TO 20050
10050 VOLD=SR(INF)
      KOLD=0
20050 IF (SR(INF).GT.FDIFER) GO TO 28
C
C     MODIFIED LAGRANGE INTERPOLATION FOR TIGHT INEQUALITIES
C
      IF (SR(INF).GT.0.0) GO TO 35
      CALL PROBLM(3)
      FINT=R(K9)
      DO 139 J=1,NX
  139 X(J)=X2(INF,J)
      CALL PROBLM(2)
      DO 40 J=K7,K8
   40 R1(J)=R(J)
      DO 41 J=1,NX
   41 X(J)=X1(KOUNT,J)
      CALL PROBLM(2)
      DO 42 J=K7,K8
   42 R3(J)=R(J)
      DO 43 J=1,NX
      H(J)=X1(KOUNT,J)-X2(INF,J)
   43 X(J)=X2(INF,J)+0.5*H(J)
      CALL PROBLM(2)
      FLG(1)=0.0
      FLG(2)=0.0
      FLG(3)=0.0
      DO 44 J=K7,K8
      IF (R3(J).GE.0.0) GO TO 44
      FLG(1)=FLG(1)+R1(J)*R1(J)
      FLG(2)=FLG(2)+R(J)*R(J)
      FLG(3)=FLG(3)+R3(J)*R3(J)
   44 CONTINUE
      SR(INF)=SQRT(FLG(1))
      IF (SR(INF).LT.FDIFER) GO TO 35
      ALFA1=FLG(1)-2.0*FLG(2)+FLG(3)
      BETA1=3.0*FLG(1)-4.0*FLG(2)+FLG(3)
      RATIO=BETA1/(4.0*ALFA1)
      DO 45 J=1,NX
   45 X(J)=X2(INF,J)+H(J)*RATIO
      IN=INF
      CALL SUMR(PROBLM)
      SR(INF)=SQRT(SEQL)
      IF (SR(INF).LT.FDIFER) GO TO 465
      DO 49 I=1,20
      DO 48 J=1,NX
   48 X(J)=X(J)-0.05*H(J)
      CALL SUMR(PROBLM)
      SR(INF)=SQRT(SEQL)
      IF (SR(INF).LT.FDIFER) GO TO 465
   49 CONTINUE
  465 CALL PROBLM(3)
      IF (FINT.GT.R(K9)) GO TO 46
      SR(INF)=0.0
      GO TO 35
   46 DO 47 J=1,NX
   47 X2(INF,J)=X(J)
   35 CONTINUE
      DO 335 J=1,NX
  335 X(J)=X2(INF,J)
      RETURN
  853 FORMAT (//' * * * * * * 㤠  ᪥ ⨬ 窨 *
     1 * * * * *')
  850 FORMAT (//'  㤮⢮ ࠭祭 ;  
     1饭'///' ,  㣮 砫쭮 ਡ  
     2 襭 ')
  851 FORMAT (//'  ᨬ ६,  ண  㤮
     1⢮ ࠭祭:'//(4(' X(',I2,')=',1PE12.5,1X)))
  852 FORMAT (//' 騩  = ',1PE12.5///' ७  㬬 
     1⮢ 襭 ࠭祭 = ',1PE12.5)
      END
      SUBROUTINE SUMR(PROBLM)
      EXTERNAL PROBLM
C
C     THIS SUBROUTINE COMPUTES THE SUM OF THE SQUARE VALUES OF THE
C     VIOLATED CONSTRAINTS IN ORDER TO BE COMPARED WITH THE TOLERANCE
C     CRITERION
C
      DIMENSION X(50),X1(50,50),X2(50,50),R(100),SUM(50),F(50),SR(50),
     1 ROLD(100)
      COMMON /FLEXC1/NX,NC,NIC,STEP,ALFA,BETA,GAMA,IN,INF,FDIFER,SEQL,
     1 K1,K2,K3,K4,K5,K6,K7,K8,K9,X,X1,X2,R,SUM,F,SR,ROLD,SCALE,FOLD
      COMMON /FLEXC2/LFEAS,L5,L6,L7,L8,L9,R1A,R2A,R3A
      SUM(IN)=0.0
      CALL PROBLM(2)
      SEQL=0.0
      IF (NIC.EQ.0) GO TO 4
      DO 1 J=K7,K8
      IF (R(J).GE.0.0) GO TO 1
      SEQL=SEQL+R(J)*R(J)
    1 CONTINUE
    4 IF (NC.EQ.0) GO TO 3
      CALL PROBLM(1)
      DO 2 J=1,NC
    2 SEQL=SEQL+R(J)*R(J)
    3 SUM(IN)=SEQL
    5 RETURN
      END
      SUBROUTINE WRITEX(PROBLM,NPR)
      EXTERNAL PROBLM
      INTEGER NPR
      DIMENSION X(50),X1(50,50),X2(50,50),R(100),SUM(50),F(50),SR(50),
     1 ROLD(100)
      COMMON /FLEXC1/NX,NC,NIC,STEP,ALFA,BETA,GAMA,IN,INF,FDIFER,SEQL,
     1 K1,K2,K3,K4,K5,K6,K7,K8,K9,X,X1,X2,R,SUM,F,SR,ROLD,SCALE,FOLD
      COMMON /FLEXC2/LFEAS,L5,L6,L7,L8,L9,R1A,R2A,R3A
      IF (NPR.GT.0) WRITE (NPR,1) (J,X(J),J=1,NX)
    1 FORMAT (//'  ᨬ ६:'//(4(' X(',I2,')=',
     1 1PE12.5,1X)))
      IF (NC.LE.0) GO TO 3
      CALL PROBLM(1)
      IF (NPR.GT.0) WRITE (NPR,2) (J,R(J),J=1,NC)
    2 FORMAT (//' 祭 ࠭祭-ࠢ:'//(4(' E(',I2,')=',
     1 1PE12.5,1X)))
    3 IF (NIC.LE.0) GO TO 5
      CALL PROBLM(2)
      IF (NPR.GT.0) WRITE (NPR,4) (J,R(NC+J),J=1,NIC)
    4 FORMAT (//' 祭 ࠭祭-ࠢ:'//(4(' Z(',I2,')=',
     1 1PE12.5,1X)))
    5 CALL PROBLM(3)
      IF (NPR.GT.0) WRITE (NPR,6) R(NC+NIC+1)
    6 FORMAT (//' 祭 楫 㭪樨 = ',1PE12.5)
      RETURN
      END
